/*
Copyright 2021 The Dapr Authors
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
    http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by mockery v1.0.0.

package testing

import (
	"github.com/dapr/components-contrib/pubsub"
)

// MockPubSubAdapter is mock for PubSubAdapter
type MockPubSubAdapter struct {
	PublishFn   func(req *pubsub.PublishRequest) error
	GetPubSubFn func(pubsubName string) pubsub.PubSub
}

// Publish is an adapter method for the runtime to pre-validate publish requests
// And then forward them to the Pub/Sub component.
// This method is used by the HTTP and gRPC APIs.
func (a *MockPubSubAdapter) Publish(req *pubsub.PublishRequest) error {
	return a.PublishFn(req)
}

// GetPubSub is an adapter method to fetch a pubsub
func (a *MockPubSubAdapter) GetPubSub(pubsubName string) pubsub.PubSub {
	return a.GetPubSubFn(pubsubName)
}
